fun abs(x)
  if x < 0 then -x else x end
end

fun loop(f, est)
  let erro = 0.00000001,
      suficiente = fun (est1, est2)
                     abs(est2 - est1) < erro * est1
                   end,
      prox = (f)(est) in
    if (suficiente)(est, prox) then prox
    else loop(f, prox) end
  end
end

fun pontoFixo(f)
  fun (est)
    loop(f, est)
  end  
end

fun deriv(f)
  let dx = 0.00000001 in
    fun (x) ((f)(x + dx) - (f)(x)) / dx end
  end
end
    
fun zeroNewton(g)
  pontoFixo(fun (x) x - (g)(x)/(deriv(g))(x) end)
end
    
fun raiz(x)
  (zeroNewton(fun (y) y * y - x end))(1.0)
end

raiz(2)
