fun eq(a, b)
  !(a < b) & !(b < a)
end

fun Var(nome)
  fun (v, ap, abs)
    (v)(nome)
  end
end

fun Ap(f, arg)
  fun (v, ap, abs)
    (ap)(f, arg)
  end
end

fun Abs(param, corpo)
  fun (v, ap, abs)
    (abs)(param, corpo)
  end
end

fun erro()
  1/0
end

fun eval(p) -- retorna um Abs
  (p)(
    fun (nome) erro() end,
    fun (f, arg)
      let vf = eval(f),
          va = eval(arg) in
        (vf)(
          fun (nome) erro() end,
          fun (f, arg) erro() end,
          fun (param, corpo)
            eval(subst(corpo, param, va))
          end
        )
      end 
    end,
    fun (param, corpo) p end
  )
end

fun subst(exp, oque, peloq)
  (exp)(
    fun (nome)
      if eq(nome, oque) then
        peloq
      else
        exp
      end
    end,
    fun (f, arg) 
      Ap(subst(f, oque, peloq),
         subst(arg, oque, peloq))
    end,
    fun (param, corpo)
      if eq(param, oque) then
        exp
      else
        Abs(param, subst(corpo, oque, peloq))
      end
    end
  )  
end

let prog = Ap(Abs(0, Abs(1, Var(0))), Abs(0, Var(0))) in
  eval(prog)
end

